# Angular DataGrid Quick Start

Learn how to use Wijmo components in Angular using this QuickStart Tutorial

## Content

Wijmo integrates with Angular through standalone components and template-based bindings.

>type=note
> Wijmo Angular interop packages support Angular 20 and later versions. 

Wijmo Angular components leverage the TypeScript class inheritance and extend the control classes they represent. This means that when you reference a Wijmo component, the instance you access is both a Wijmo control (with all its properties, events, and methods), and an Angular component at the same time. These components also integrate smoothly with Angular’s data binding system, supporting both one-way and two-way bindings, as well as event handling.
Since Wijmo controls, Angular components, and Angular are all built with TypeScript, they work together naturally, ensuring a consistent and efficient development experience.
In this section, we talk about Wijmo Angular 2 components, Angular markup syntax and provide a quick start guide to help you add Wijmo components to your Angular applications.

## Angular Quick Start

This topic walks you through setting up Wijmo with an Angular project. For demonstration purpose, we are using Wijmo's FlexGrid as a standalone Angular component and see how to create an Angular DataGrid.
Note that, in this topic, we assume that the user understands how to create an Angular application using Angular CLI. For more information, read Angular CLI on Angular’s [official website](https://angular.dev/tools/cli/setup-local).
1\. Install Wijmo Packages
2\. Import Wijmo Components and data
3\. Add Angular DataGrid Markup

## Install Wijmo Packages

1. Open your angular application and switch to the application folder where you want to install the package.
2. Install Wijmo Angular packages by using the following command: npm install @mescius/wijmo.angular2.all

## Import Wijmo Modules and Data

1. Import the required modules.
2. Include Wijmo modules in the import array. For our FlexGrid example, we are including the following in app.component.ts file.

    ```javascript
    import { Component } from '@angular/core';
    import { WjFlexGrid, WjFlexGridColumn } from '@mescius/wijmo.angular2.grid';
    ```
3. Define data to be bound with Angular Datagrid.

    ```javascript
    @Component({
      selector: 'app-root',
      standalone: true,
      imports: [WjFlexGrid, WjFlexGridColumn],
      templateUrl: './app.component.html',
      styleUrl: './app.component.css',
    })
    export class AppComponent {
      data = [
        { id: 0, country: 'US', sales: 1318.37, expenses: 4212.41 },
        { id: 1, country: 'Germany', sales: 5847.95, expenses: 89.79 },
        { id: 2, country: 'UK', sales: 502.55, expenses: 2878.50 },
        { id: 3, country: 'Japan', sales: 4675.40, expenses: 488.65 },
        { id: 4, country: 'Italy', sales: 2117.57, expenses: 925.60 },
        { id: 5, country: 'Greece', sales: 322.10, expenses: 4163.96 }
      ];
    }
    ```
4. In styles.css file, add the following import statement to load styles in the Angular CLI application.

    ```javascript
     @import '@mescius/wijmo.styles/wijmo.css';
    ```

## Angular 21 Zoneless Mode

Angular 21 applications created with the default configuration use zoneless change detection.
Wijmo Angular components support zoneless mode without any additional Wijmo-specific configuration. The runtime automatically detects and adapts to both Zone.js and zoneless environments.

## Configuring Zone.js for Existing Projects

If you are adding Wijmo to an existing Angular 21 application that was created with the default Zoneless change detection, follow these steps to restore Zone.js:

1. **Install zone.js**

```
npm install zone.js
```

2. **Add zone.js to angular.json polyfills**
    Open your `angular.json` and add `zone.js` to the **polyfills** array in both the **build** and **test** targets:

```
{
    "projects": {
        "my-wijmo-app": {
            "architect": {
                "build": {
                    "options": {
                        "polyfills": ["zone.js"]
                    }
                },
                "test": {
                    "options": {
                        "polyfills": ["zone.js", "zone.js/testing"]
                    }
                }
            }
        }
    }
}
```

>type=warning
> **Important**: Without this step, `zone.js` will not be loaded into the browser at runtime, and the `provideZoneChangeDetection` provider configured in the next step will have no effect.

3. **Replace provideExperimentalZonelessChangeDetection with provideZoneChangeDetection**
    Open your `app.config.ts` and replace the change detection provider:

```
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
export const appConfig: ApplicationConfig = {
    providers: [
        provideZoneChangeDetection({ eventCoalescing: true })
    ]
};
```

>type=note
> **Note**: The eventCoalescing: true option improves performance by batching multiple change detection cycles triggered by the same event into a single cycle.

Run the application to observe the Wijmo FlexGrid successfully integrated into your Angular application. To explore additional user-friendly Wijmo components like charts, input controls, and pivot grids, see [Wijmo Demos](https://developer.mescius.com/wijmo/demos/).

# Using Wijmo with Vue

Learn how to use Wijmo components in Vue using this QuickStart Tutorial

## Content

<span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:
Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos">Wijmo provides built-in support for Vue, enabling developers to integrate powerful UI components seamlessly into Vue applications. With Wijmo’s lightweight and high-performance controls, you can build responsive, data-driven applications while leveraging Vue’s reactive and component-based architecture.</span>
<span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:
Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos">Wijmo components for Vue allow you to use Wijmo controls within Vue templates markup. Each Wijmo Vue component acts as a wrapper for its corresponding Wijmo control. It automatically creates the Wijmo control instance behind the scenes which is accessible through the </span><span lang="EN-US" style="font-family:Consolas;
mso-fareast-font-family:Consolas;mso-bidi-font-family:Consolas">control</span><span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:Aptos;
mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos"> property. Additionally, these components allow declarative binding to control properties and events directly within the Vue template markup.</span>

> type=note
> **<span lang="EN-US">Note</span>**<span lang="EN-US">: If you are using Wijmo with Vue 2, we recommend migrating to Vue 3 and updating the existing custom components to ensure complete compatibility.</span>

## <span lang="EN-US">Vue3 Quick Start</span>

<span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:
Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos;color:black;
mso-themecolor:text1">This topic walks you through setting up Wijmo with a Vue3 project. For demonstration purpose, we are using Wijmo's FlexGrid component and see how to create a Vue 3 DataGrid, utilizing </span>**<span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:
Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos;color:black;
mso-themecolor:text1">Composition API</span>** <span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:
Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos;color:black;
mso-themecolor:text1">(Custom component level registration method)</span>**<span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:
Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos;color:black;
mso-themecolor:text1">.</span>**
![Vue3](https://cdn.mescius.io/document-site-files/images/3c7113e2-10b3-45ed-8f3b-9fb1e0af2b74/Vue3.3aff7a.png)

> type=note
> <span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:
> Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos;color:black;
> mso-themecolor:text1">Note that the topic assumes that the user understands how to create a Vue3 application using Vue CLI. For more information, see </span>[<span style="mso-ascii-font-family:Aptos;mso-fareast-font-family:Aptos;mso-hansi-font-family:
> Aptos;mso-bidi-font-family:Aptos">Vue CLI</span>](https://cli.vuejs.org/#getting-started)<span lang="EN-US" style="mso-ascii-font-family:Aptos;mso-fareast-font-family:Aptos;mso-hansi-font-family:
> Aptos;mso-bidi-font-family:Aptos;color:black;mso-themecolor:text1">.</span>

The QuickStart is categorized into the following sections:

1. <span style="mso-ascii-font-family:Aptos;mso-fareast-font-family:Aptos;
    mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos;color:black;mso-themecolor:
    text1" lang="EN-US">Install Wijmo Packages</span>
2. <span style="mso-ascii-font-family:
    Aptos;mso-fareast-font-family:Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:
    Aptos;color:black;mso-themecolor:text1" lang="EN-US">Import Wijmo Components and Data</span>
3. <span style="mso-ascii-font-family:
    Aptos;mso-fareast-font-family:Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:
    Aptos;color:black;mso-themecolor:text1" lang="EN-US">Adding Vue Datagrid Markup</span>

### Install Wijmo Packages

1. <span style="mso-ascii-font-family:Aptos;mso-fareast-font-family:Aptos;
    mso-hansi-font-family:Aptos;mso-bidi-font-family:Aptos;color:black;mso-themecolor:
    text1" lang="EN-US">Open your Vue application and switch to the application folder where you want to install the package.</span>
2. <span style="mso-list:Ignore">I</span><span style="mso-ascii-font-family:
    Aptos;mso-fareast-font-family:Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:
    Aptos;color:black;mso-themecolor:text1" lang="EN-US">nstall Wijmo's Vue package using npm</span><span style="mso-spacerun:yes">  </span>by running the following command:

    ```auto
    npm install @mescius/wijmo.vue2.all
    ```

### Import Wijmo Modules and Data

1. Import the required Wijmo Component and directive and register them at Component level. For our FlexGrid example, we will add a *wj-flex-grid* component to the App.vue file’s template section by including the code in the following files:
    1. **App.Vue file**

        ```auto
        <script setup>=
        import * as wjcCore from "@mescius/wijmo";
        import { ref } from "vue";
        const data = ref(_getData()); 
        function _getData() {
          // create some
           random data
           let countries ="US,Germany,UK,Japan,Italy,Greece".split(","),
            data = [];
            for (let i = 0; i< countries.length; i++) {
              data.push({
                  id: i,
                  country:
            countries[i],
                  sales:Math.random() * 10000,
                  expenses:Math.random() * 5000,
              });
          }
          return data;
        }
        </script> 
        
        <template>
        
          <div class="container-fluid">
        
           </div>
        
        </template>
        ```
    2. **Main.js file**

        ```auto
        import '@mescius/wijmo.styles/wijmo.css';
        import { createApp } from "vue";
        import App from "./App.vue";
        import { registerGrid } from "@mescius/wijmo.vue2.grid";
        const app = createApp(App);
        registerGrid(app);
        app.mount('#app');
        ```
2. In the **main.js** file, add a CSS import statement at the top of the file to import the Wijmo CSS.

    ```auto
    import '@mescius/wijmo.styles/wijmo.css';
    ```

### Adding Vue Datagrid Markup

The WjFlexGrid component is written as wj-flex-grid, as for HTML the lower-case-dash syntax is used.

```auto
<template>
  <div class="container-fluid"> 
<wj-flex-grid :itemsSource="data"
:initialized="flexInitialized">         
<wj-flex-grid-column :header="'Country'"
:binding="'country'" width="2*" />        
<wj-flex-grid-column :header="'Sales'"
:binding="'sales'" width="*" format="n2" />         
<wj-flex-grid-column :header="'Expenses'"
:binding="'expenses'" width="*" format="n2" />     
</wj-flex-grid>
  </div>
</template>
```

**Run the application**
<span lang="EN-US" style="mso-ascii-font-family:Aptos;
mso-fareast-font-family:Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:
Aptos;color:black;mso-themecolor:text1">You have successfully integrated Wijmo FlexGrid into your Vue application. To explore additional Wijmo components like charts, input controls, and pivot grids, see </span>*[<span style="mso-ascii-font-family:
Aptos;mso-fareast-font-family:Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:
Aptos">Wijmo Demos</span>](https://developer.mescius.com/wijmo/demos/)*<span lang="EN-US" style="mso-ascii-font-family:
Aptos;mso-fareast-font-family:Aptos;mso-hansi-font-family:Aptos;mso-bidi-font-family:
Aptos;color:black;mso-themecolor:text1">.</span>

# Using Wijmo with React

Learn how to use Wijmo components in React using this QuickStart Tutorial

## Content

Wijmo *components* for React allow you to use Wijmo *controls* in React JSX syntax. A Wijmo React *component* is a wrapper for the Wijmo *control* it represents. *Component* creates a Wijmo *control* behind the scenes, and provides a reference to the control instance via the **control** property. *Component* allows you to bind to the *control* properties and events declaratively in the React JSX syntax.

**Note** We highly recommend that you [download the Wijmo dev kit](https://developer.mescius.com/download/wijmo-enterprise) in addition to installing from npm. The dev kit includes hundreds of samples with source code, reference apps and more.

## Installation

Wijmo React components are shipped as a set of npm packages, one package per core library package, with the "react" word in their names. For example, "wijmo.react.grid" package represents components for controls from the core "wijmo.grid" package. The packages can be installed separately, or all together using the "@mescius/wijmo.react.all" group package:

```auto
npm install @mescius/wijmo.react.all
```

## Importing Wijmo components

With this setup, you can import Wijmo React modules and use the components they contain. For example, this code adds a FlexGrid component to App component's JSX:

```javascript
import * as React from 'react';
import * as wjcGrid from '@mescius/wijmo.react.grid';

const App: React.FC = () => {
  const [data, setData] = React.useState(getData());

  return <wjcGrid.FlexGrid itemsSource={data} />
}
```

## Adding Wijmo css

For Wijmo controls to look and work correctly, you need to load Wijmo css styles into
your application. The styles are shipped in the **@mescius/wijmo.styles** npm package.

You can load styles in your application's .jsx/.js root file, using this ESM import statement:

```javascript
import '@mescius/wijmo.styles/wijmo.css';
```

## More React Instrucitons

Refer to the [React Components](/wijmo/docs/GettingStarted/React-Components) topic for more details on using Wijmo in React applications.